/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8910_SUPSTPS.sql

Descrio:
- insere os dados selecionados para apurao da compra

Criao:
20/09/2006 - Raquel Cunha
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'APURA_COMPRA' AND
              TYPE = 'P'                  AND
              U.UID = O.UID               AND
              U.NAME = USER)
   DROP PROCEDURE APURA_COMPRA;
GO

CREATE PROCEDURE APURA_COMPRA
   @P_CDCENTCMP  VARCHAR(4),
   @P_NRSEQAPUR  VARCHAR(10),
   @P_DTINI      DATETIME,
   @P_DTFIN      DATETIME,
   @P_FILIPROC   VARCHAR(4),
   @P_ROWSAFFECT VARCHAR(1) OUTPUT,
   @P_CDOPERLANC VARCHAR(12),
   @P_CDCOMPRADOR VARCHAR(12),
   @P_NRCOMPRA VARCHAR(10)
AS
   DECLARE @V_QTACOMPRAR     NUMERIC(10, 3);
   DECLARE @V_QTACOMPRAR_AUX NUMERIC(10, 3);
   DECLARE @V_QTDECOMP       NUMERIC(10, 3);
   DECLARE @V_CTPRODATIV     INT;
   DECLARE @V_CTPRODCMP      INT;
   DECLARE @V_CTIMPOSTO      INT;
   DECLARE @V_VRARREDCMP     FLOAT;
   DECLARE @V_IDPRODWEB      VARCHAR(1);
   DECLARE @V_IDAFOPERLOG    VARCHAR(1);
   DECLARE @V_IDCONSPRSOL    VARCHAR(1);
   DECLARE @V_VRARREDEMPE    FLOAT;
   DECLARE @V_CDEMPRESA      VARCHAR(2);
   DECLARE @V_CONCKEY        VARCHAR(200);
   DECLARE @V_IDTIPEMIT      VARCHAR(1);
   DECLARE @V_EMITENTE       VARCHAR(4);
   DECLARE @V_DSPZOPGTCONC   VARCHAR(2000);
   DECLARE @V_IDUTISTATCOT   VARCHAR(1);
   DECLARE @V_AUX_LISTA      VARCHAR(2000);
   DECLARE @V_IDSEPAFIMP     VARCHAR(1);
   DECLARE @V_CDFILIOPELOG   VARCHAR(2000);
   DECLARE @V_IDPRODATIV     VARCHAR(1);
   DECLARE @V_COUNT          INT;

   DECLARE @V_FILGRUPFILI_CDFILIAL VARCHAR(4);

   DECLARE @V_ITEMSOLI_CDPRODESTO VARCHAR(10);
   DECLARE @V_ITEMSOLI_CDPRODUTO  VARCHAR(10);
   DECLARE @V_ITEMSOLI_CDFILSOLI  VARCHAR(4);
   DECLARE @V_ITEMSOLI_DTPROGENTR DATETIME;
   DECLARE @V_ITEMSOLI_CDREGIAO   VARCHAR(3);
   DECLARE @V_ITEMSOLI_QTDEACOMP  NUMERIC(10, 3);

   DECLARE @V_GRAVA_CDFILIAL VARCHAR(4);
   DECLARE @V_GRAVA_CDPRODUTO VARCHAR(10);
   DECLARE @V_GRAVA_VRFATOCONV DOUBLE PRECISION;
   DECLARE @V_GRAVA_NRCOLEPRECO VARCHAR(10);
   DECLARE @V_GRAVA_CDFORNECED VARCHAR(21);
   DECLARE @V_GRAVA_CDREGIAO VARCHAR(3);
   DECLARE @V_GRAVA_CDMARCA VARCHAR(5);
   DECLARE @V_GRAVA_CDTIPCOB VARCHAR(2);
   DECLARE @V_GRAVA_CDFORMPGTO VARCHAR(2);
   DECLARE @V_GRAVA_IDUTDIAPGCOL VARCHAR(1);
   DECLARE @V_GRAVA_IDTPFOPGTCOL VARCHAR(1);
   DECLARE @V_GRAVA_IDTIPFREITM VARCHAR(1);
   DECLARE @V_GRAVA_NRPARCPGTCOL NUMERIC;
   DECLARE @V_GRAVA_CDSEGMARCCOL VARCHAR(5);
   DECLARE @V_GRAVA_VRPRECUNIITM DOUBLE PRECISION;
   DECLARE @V_GRAVA_VRPERDESITM DOUBLE PRECISION;
   DECLARE @V_GRAVA_NRDIAPGFXCOL NUMERIC;
   DECLARE @V_GRAVA_VRPRECECOITM DOUBLE PRECISION;
   DECLARE @V_GRAVA_VRPRECOITMPI DOUBLE PRECISION;
   DECLARE @V_GRAVA_IDITMLISPREC VARCHAR(1);
   DECLARE @V_GRAVA_NRSEQPRELIST VARCHAR(10);
   DECLARE @V_CDFILIAL VARCHAR(4);
   DECLARE @V_CDFILIAL_PARAM VARCHAR(4);;
BEGIN
   SET @P_ROWSAFFECT = 'N';
   SET @V_QTACOMPRAR = 0;

   SELECT
      @V_IDCONSPRSOL  = MAX(IDCONSPRSOL), /* Considerar somente Produto Solicitado para Cotao e AF Automtica */
      @V_IDSEPAFIMP   = MAX(IDSEPAFIMP), /*Gera AF's Separadas de Acordo com o Imposto*/
      @V_IDUTISTATCOT = MAX(ISNULL(IDUTISTATCOT, 'N'))
   FROM
      PARASUPRI
   WHERE
      CDFILIAL = @P_CDCENTCMP;

   INSERT INTO APURPRECO
      (CDFILCENTCMP, NRAPURPREC, CDCOMPRADOR, DTINIAPUPREC,
       DTFINAPUPREC, IDSITAPUPREC, DTAPURPREC,CDOPERADOR, CDFILLANC)
   VALUES
      (@P_CDCENTCMP, @P_NRSEQAPUR, @P_CDCOMPRADOR, @P_DTINI,
       @P_DTFIN, '1', GETDATE(), @P_CDOPERLANC, @P_FILIPROC);

   INSERT INTO APROVCOMPRA
   (NRCOMPRA, CDGERENTE)
   SELECT @P_NRCOMPRA, CDOPERGERE
     FROM GERECOMP G
    WHERE CDOPERCOMP = @P_CDCOMPRADOR
      AND NOT EXISTS (SELECT 1
                        FROM APROVCOMPRA AC
                       WHERE AC.NRCOMPRA  = @P_NRCOMPRA
                         AND G.CDOPERGERE = AC.CDGERENTE);



   DECLARE C_FILGRUPFILI CURSOR FOR
      (SELECT DISTINCT
          PRODCOMPRA.CDFILSOLI AS CDFILIAL
       FROM
          PRODCOMPRA
       WHERE
          (PRODCOMPRA.NRCOMPRA = @P_NRCOMPRA)
       )
   OPEN C_FILGRUPFILI;
   FETCH NEXT FROM C_FILGRUPFILI INTO @V_FILGRUPFILI_CDFILIAL;
   WHILE (@@FETCH_STATUS = 0) BEGIN


      IF ISNULL(@V_IDCONSPRSOL, 'N') = 'N' BEGIN



         DECLARE C_ITEMSOLI CURSOR FOR
            (SELECT /*+ ORDERED */
                PRODUTO.CDPRODESTO,
                ITEMSOLI.CDFILSOLI,
                ITEMSOLI.DTPROGENTR,
                FILIAL.CDREGIAO,
                SUM(CASE ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV
                       WHEN NULL THEN 0
                       ELSE ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV
                    END) QTDEACOMP /* QUANTIDADE CONVERTIDA PARA ESTOQUE */
             FROM
                FILIAL,
                PRODCOMPRA,
                ITEMSOLI,
                PRODUTO
             WHERE
                (FILIAL.CDFILIAL      = @V_FILGRUPFILI_CDFILIAL)     AND
                (PRODCOMPRA.NRCOMPRA  = @P_NRCOMPRA)                 AND
                (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)            AND
                (ITEMSOLI.CDFILSOLI   = PRODCOMPRA.CDFILSOLI)       AND
                (ITEMSOLI.CDFILLAN    = PRODCOMPRA.CDFILLAN)        AND
                (ITEMSOLI.NRSOLICMP   = PRODCOMPRA.NRSOLICMP)       AND
                (ITEMSOLI.CDPRODUTO   = PRODCOMPRA.CDPRODUTO)       AND
                (ITEMSOLI.DTPROGENTR  = PRODCOMPRA.DTPROGENTR)      AND
                (ITEMSOLI.IDITMCONS   = 'N')                        AND
                (ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) =  @P_CDCENTCMP) AND
                (FILIAL.IDCNTRRESC   <> 'S') AND
                (ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO) AND
                (CASE ITEMSOLI.IDSOLIAPROV
                    WHEN NULL THEN 'S'
                    ELSE ITEMSOLI.IDSOLIAPROV
                 END) = 'S' AND
                EXISTS(SELECT
                          1
                       FROM
                          PRODCOMP,
                          PRODUTO PC
                       WHERE
                          PRODCOMP.CDPRODUTO  = PC.CDPRODUTO         AND
                          PRODCOMP.CDOPERADOR = @P_CDCOMPRADOR AND
                          PRODUTO.CDARVPROD LIKE PC.CDARVPROD + '%')
                       GROUP BY
                          FILIAL.CDREGIAO,
                          ITEMSOLI.CDFILSOLI,
                          PRODUTO.CDPRODESTO,
                          ITEMSOLI.DTPROGENTR)
         OPEN C_ITEMSOLI;
         FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_CDPRODESTO,
                                         @V_ITEMSOLI_CDFILSOLI,
                                         @V_ITEMSOLI_DTPROGENTR,
                                         @V_ITEMSOLI_CDREGIAO,
                                         @V_ITEMSOLI_QTDEACOMP;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT
               @V_IDPRODATIV = ISNULL(MAX(PRODFILI.IDPRODATIV), 'A')
            FROM
               PRODFILI
            WHERE
               PRODFILI.CDFILIAL  = @V_ITEMSOLI_CDFILSOLI AND
               PRODFILI.CDPRODUTO = @V_ITEMSOLI_CDPRODESTO;

            IF @V_IDPRODATIV = 'A' BEGIN
               SET @V_CTPRODCMP = 0;
               SELECT
                  @V_CTPRODCMP = COUNT(*)
               FROM
                  PRODCMPFILI,
                  PRODUTO,
                  PRODUTO PRODESTO
               WHERE
                  PRODESTO.CDPRODUTO    = @V_ITEMSOLI_CDPRODESTO  AND
                  PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO      AND
                  PRODCMPFILI.CDFILIAL  = @V_ITEMSOLI_CDFILSOLI   AND

                  PRODCMPFILI.CDFILIAL <> @P_FILIPROC             AND
                  PRODESTO.CDARVPROD LIKE PRODUTO.CDARVPROD+'%' AND
                  PRODUTO.CDARVPROD > (SELECT (CASE MAX(PR.CDARVPROD) WHEN NULL THEN '0' ELSE MAX(PR.CDARVPROD) END)
                                       FROM PRODNCMP, PRODUTO PR
                                       WHERE PRODNCMP.CDPRODUTO = PR.CDPRODUTO AND
                                             PRODESTO.CDARVPROD LIKE PR.CDARVPROD+'%' AND
                                             PRODNCMP.CDFILIAL = @V_ITEMSOLI_CDFILSOLI);

               IF @V_CTPRODCMP = 0 BEGIN
                  SET @V_CTPRODCMP = 1;
               END ELSE BEGIN
                  SET @V_CTPRODCMP = 0;
               END;

               IF @V_CTPRODCMP > 0 BEGIN
                  SET @V_QTACOMPRAR = @V_ITEMSOLI_QTDEACOMP;
                  IF @V_QTDECOMP IS NULL BEGIN
                     SET @V_QTDECOMP = 0;
                  END;
                  
                  SELECT /*+ index (itemautf itemautf_03) */
                     V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF * PRODUTO.VRFATOCONV) /* QTDE CONVERTIDA PARA ESTOQUE */
                  FROM
                    AUTOFORNE,
                    ITEMAUTF,
                    PRODUTO,
                    ITMAPURPREC
                  WHERE
                    (PRODUTO.CDPRODESTO     = @V_ITEMSOLI_CDPRODUTO)                     AND
                    (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)                        AND
                    (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)                        AND
                    (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN)                       AND
                    (AUTOFORNE.IDAUTOFORNEX = 'N')                                       AND
                    (ISNULL(AUTOFORNE.IDBAIXAAF, '0') <> '5')                            AND
                    (ITEMAUTF.CDFILDEST     = @V_ITEMSOLI_CDFILSOLI)                     AND
                    (ITEMAUTF.CDPRODUTO     = PRODUTO.CDPRODUTO)                         AND
                    (ITEMAUTF.DTENTRITMSOL  = @V_ITEMSOLI_DTPROGENTR)                    AND
                    (ITEMAUTF.CDFILDEST     = ITMAPURPREC.CDFILIAP)                      AND
                    (ITEMAUTF.CDMARCA       = ITMAPURPREC.CDMARCITMAP)                   AND
                    (ITEMAUTF.CDPRODUTO     = ITMAPURPREC.CDPRODITMAP)                   AND
                    (ITEMAUTF.DTPROGENTAF   = ITMAPURPREC.DTENTRAPUT)                    AND
                    (AUTOFORNE.CDFORNECED   = ITMAPURPREC.CDFORNITMAP)                   AND
                    (AUTOFORNE.NRSEQAPURAF  = ITMAPURPREC.NRSEQITMAP)                    AND
                    (ISNULL(ITMAPURPREC.NRCOMPRA, @P_NRCOMPRA)  =  @P_NRCOMPRA)          AND
                    (ITMAPURPREC.NRCOMPRA IS NOT NULL)
                  GROUP BY
                    ITEMAUTF.CDFILDEST,
                    ITEMAUTF.DTENTRITMSOL,
                    PRODUTO.CDPRODESTO;

                  SET @V_QTACOMPRAR = @V_QTACOMPRAR - @V_QTDECOMP;

                  IF ROUND(@V_QTACOMPRAR,3) > 0 BEGIN
                     -- DBMS_OUTPUT.PUT_LINE('COLETA');

                     DECLARE C_GRAVA CURSOR FOR (
                        SELECT /*+ INDEX(ITEMCOLE ITEMCOLE_01)*/
                           ITEMCOLE.CDFILIAL,
                           ITEMCOLE.CDPRODUTO,
                           PRODUTO.VRFATOCONV,
                           ITEMCOLE.NRCOLEPRECO,
                           ITEMCOLE.CDFORNECED,
                           ITEMCOLE.CDREGIAO,
                           ITEMCOLE.CDMARCA,
                           ITEMCOLE.CDTIPCOB,
                           ITEMCOLE.CDFORMPGTO,
                           ITEMCOLE.IDUTDIAPGCOL,
                           ITEMCOLE.IDTPFOPGTCOL,
                           ITEMCOLE.IDTIPFREITM,
                           ITEMCOLE.NRPARCPGTCOL,
                           ITEMCOLE.CDSEGMARCCOL,
                           ITEMCOLE.VRPRECUNIITM,
                           ITEMCOLE.VRPERDESITM,
                           ITEMCOLE.NRDIAPGFXCOL,
                           ITEMCOLE.VRPRECECOITM,
                           ITEMCOLE.VRPRECOITMPI,
                           ITEMCOLE.IDITMLISPREC,
                           ITEMCOLE.NRSEQPRELIST,
                           ITEMCOLE.DSPZOPGTCONC --T R I G G E R
                        FROM
                           ITEMCOLE,
                           PRODUTO,
                           FORNECEDOR,
                           COLETAPR
                        WHERE
                           COLETAPR.CDFILIAL      = @P_CDCENTCMP                                         AND
                           COLETAPR.CDOPERADOR    = @P_CDCOMPRADOR                                       AND
                           COLETAPR.NRCOMPRA      = @P_NRCOMPRA                                          AND
                           COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL                                   AND
                           COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO                                AND
                           PRODUTO.CDPRODUTO      = ITEMCOLE.CDPRODUTO                                  AND
                           ITEMCOLE.VRPRECUNIITM  <> 0                                                  AND
                           PRODUTO.CDPRODESTO     = @V_ITEMSOLI_CDPRODESTO                               AND
                           ITEMCOLE.CDREGIAO      = @V_ITEMSOLI_CDREGIAO                                 AND
                           @V_ITEMSOLI_DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM  AND
                           FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED AND
                           FORNECEDOR.IDSITUCADA  = 'A'                 AND
                           FORNECEDOR.IDTIPOFORN <> 'A'                 AND
                           ((@V_IDUTISTATCOT = 'N') OR (ISNULL(COLETAPR.IDSITUCOLETA, 'C') = 'C')) AND

                           NOT EXISTS
                              (SELECT
                                  1
                               FROM
                                  REFOREG
                               WHERE
                                  REFOREG.CDREGIAO   = @V_ITEMSOLI_CDREGIAO AND
                                  REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED) AND

                           NOT EXISTS
                              (SELECT
                                  1
                               FROM
                                  QFOPRODFORN,
                                  PARASUPRI
                               WHERE
                                  PARASUPRI.CDFILIAL = @P_CDCENTCMP  AND
                                  (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                                  (QFOPRODFORN.CDFORNECED= ITEMCOLE.CDFORNECED) AND
                                  ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                                  ((QFOPRODFORN.IDFORNAPROV = 'S') AND
                                  ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                    COLETAPR.DTCOLEPREC > DATEADD(MM, 1, QFOPRODFORN.DTVALPRFORN) - DAY(DATEADD(MM, 1, QFOPRODFORN.DTVALPRFORN))) OR
                                    (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                     COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)) ) )) AND

                           NOT EXISTS
                              (SELECT
                                  1
                               FROM
                                  QFOMARPROD,
                                  PARASUPRI
                               WHERE
                                  (PARASUPRI.CDFILIAL = @P_CDCENTCMP)            AND
                                  (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                                  (QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA)     AND
                                  ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                                  ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                                  ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                    COLETAPR.DTCOLEPREC > DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA) - DAY(DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA))) OR
                                    (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                     COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)) ) )) AND

                           EXISTS
                              (SELECT
                                  1
                               FROM
                                  QFOMARPROD
                               WHERE
                                  QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
                                  QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA

                               UNION

                               SELECT
                                  1
                               FROM
                                  PARASUPRI
                               WHERE
                                  PARASUPRI.CDFILIAL    = @P_CDCENTCMP AND
                                  (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) AND

                           NOT EXISTS
                              (SELECT
                                  1
                               FROM
                                  QUALIFICACAO,
                                  PARASUPRI
                               WHERE (FORNECEDOR.CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
                                     (PARASUPRI.CDFILIAL        = @P_CDCENTCMP)           AND
                                     (FORNECEDOR.IDFORNAUTO     = 'N')                   AND
                                     ((QUALIFICACAO.IDPERCOTCMP = '2')                   OR
                                      ((PARASUPRI.IDULTIDTVALQ  = 'D'                    AND
                                        COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF)       OR
                                      (PARASUPRI.IDULTIDTVALQ = 'M'                      AND
                                       COLETAPR.DTCOLEPREC > DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF) - DAY(DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF))) ))) AND

                           NOT EXISTS /* Tirando fornecedores que no atendam s filiais */
                              (SELECT
                                  1
                               FROM
                                  REFORFIL
                               WHERE
                                  REFORFIL.CDFILIAL   = @V_ITEMSOLI_CDFILSOLI AND
                                  REFORFIL.CDPERIENTR IS NULL AND
                                  REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED) )
                     OPEN C_GRAVA;
                     FETCH NEXT FROM C_GRAVA INTO @V_GRAVA_CDFILIAL,
                                                  @V_GRAVA_CDPRODUTO,
                                                  @V_GRAVA_VRFATOCONV,
                                                  @V_GRAVA_NRCOLEPRECO,
                                                  @V_GRAVA_CDFORNECED,
                                                  @V_GRAVA_CDREGIAO,
                                                  @V_GRAVA_CDMARCA,
                                                  @V_GRAVA_CDTIPCOB,
                                                  @V_GRAVA_CDFORMPGTO,
                                                  @V_GRAVA_IDUTDIAPGCOL,
                                                  @V_GRAVA_IDTPFOPGTCOL,
                                                  @V_GRAVA_IDTIPFREITM,
                                                  @V_GRAVA_NRPARCPGTCOL,
                                                  @V_GRAVA_CDSEGMARCCOL,
                                                  @V_GRAVA_VRPRECUNIITM,
                                                  @V_GRAVA_VRPERDESITM,
                                                  @V_GRAVA_NRDIAPGFXCOL,
                                                  @V_GRAVA_VRPRECECOITM,
                                                  @V_GRAVA_VRPRECOITMPI,
                                                  @V_GRAVA_IDITMLISPREC,
                                                  @V_GRAVA_NRSEQPRELIST,
                                                  @V_DSPZOPGTCONC;

                     WHILE (@@FETCH_STATUS = 0) BEGIN


                        SET @V_CTIMPOSTO = NULL;
                        SET @V_CONCKEY   = NULL;
                        IF @V_IDSEPAFIMP = 'S' BEGIN
                           SELECT
                              @V_CTIMPOSTO = COUNT(*)
                           FROM
                              IMPCOLET
                           WHERE
                              CDFILIAL    = @V_GRAVA_CDFILIAL    AND
                              NRCOLEPRECO = @V_GRAVA_NRCOLEPRECO AND
                              CDMARCA     = @V_GRAVA_CDMARCA     AND
                              CDREGIAO    = @V_GRAVA_CDREGIAO    AND
                              CDFORNECED  = @V_GRAVA_CDFORNECED  AND
                              CDPRODUTO   = @V_GRAVA_CDPRODUTO;

                           IF @V_CTIMPOSTO = 0 BEGIN
                              SET @V_CONCKEY = '';
                           END ELSE BEGIN
                              IF @V_CTIMPOSTO = 1 BEGIN
                                 SELECT DISTINCT
                                    @V_CONCKEY = CDIMPOSTO
                                 FROM
                                    IMPCOLET
                                 WHERE
                                    CDFILIAL    = @V_GRAVA_CDFILIAL    AND
                                    NRCOLEPRECO = @V_GRAVA_NRCOLEPRECO AND
                                    CDMARCA     = @V_GRAVA_CDMARCA     AND
                                    CDREGIAO    = @V_GRAVA_CDREGIAO    AND
                                    CDFORNECED  = @V_GRAVA_CDFORNECED  AND
                                    CDPRODUTO   = @V_GRAVA_CDPRODUTO;
                              END ELSE BEGIN
                                 IF @V_CTIMPOSTO > 1 BEGIN
                                    SET @V_CONCKEY = '*';
                                 END;
                              END;
                           END;
                        END;
                        SET @V_EMITENTE  = TEKNISA.EMITENTE(@V_ITEMSOLI_CDFILSOLI, @V_GRAVA_CDPRODUTO, @V_GRAVA_CDFORNECED);
                        SET @V_CDEMPRESA = SUBSTRING(@V_EMITENTE, 3, 2);

                        SET @V_CONCKEY   = ISNULL(@V_CONCKEY, '') + @V_GRAVA_CDFILIAL + @V_GRAVA_CDFORNECED + ISNULL(SUBSTRING(@V_EMITENTE, 3, 2), '')+
                                           ISNULL(@V_GRAVA_IDTPFOPGTCOL, '') +
                                           ISNULL(@V_GRAVA_CDTIPCOB, '')     + ISNULL(@V_GRAVA_IDTIPFREITM, '')  +
                                           ISNULL(@V_GRAVA_CDFORMPGTO, '')   + ISNULL(CONVERT(VARCHAR, @V_GRAVA_NRPARCPGTCOL), '') +
                                           ISNULL(CONVERT(VARCHAR, @V_GRAVA_NRDIAPGFXCOL), '') + ISNULL(@V_GRAVA_IDUTDIAPGCOL, '') +
                                           ISNULL(SUBSTRING(@V_EMITENTE, 1, 1), '');

                        SET @V_IDTIPEMIT = ISNULL(SUBSTRING(@V_EMITENTE, 1, 1), '');

                        SELECT
                           @V_VRARREDCMP = ISNULL(MAX(VRARREDCMP), 0)
                        FROM
                           PRODUTO
                        WHERE
                           CDPRODUTO = @V_GRAVA_CDPRODUTO;

                        SET @V_QTACOMPRAR_AUX = @V_QTACOMPRAR / @V_GRAVA_VRFATOCONV; /* CONVERTE PARA UNIDADE DE COMPRA */
                        IF @V_VRARREDCMP > 0 BEGIN
                           IF (((CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP)  - (ROUND(@V_QTACOMPRAR_AUX / @V_VRARREDCMP, 0, 1))) <> 0) AND @V_VRARREDCMP > 0 BEGIN
                              SET @V_QTACOMPRAR_AUX = CEILING(CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP) * @V_VRARREDCMP;
                           END;
                        END;
                        SET @V_IDAFOPERLOG = 'X';

                        SELECT
                           @V_IDAFOPERLOG = ISNULL(MAX('2'),'X')
                        FROM
                           PARAMPRODSUP
                        WHERE
                           CDFILIAL     = @V_ITEMSOLI_CDFILSOLI AND
                           CDPRODUTO    = @V_GRAVA_CDPRODUTO    AND
                           CDFILIOPELOG IS NOT NULL;

                        SET @V_IDPRODWEB = 'N';

                        SELECT
                           @V_IDPRODWEB = ISNULL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
                        FROM
                           PARAMPRODSUP
                        WHERE
                           CDFILIAL   = @V_ITEMSOLI_CDFILSOLI AND
                           CDPRODUTO  = @V_GRAVA_CDPRODUTO    AND
                           CDFORNECED = @V_GRAVA_CDFORNECED;

                        SELECT
                           @V_CDFILIOPELOG = MAX(CDFILIOPELOG)
                        FROM
                           PARAMPRODSUP
                        WHERE
                           CDFILIAL     = @V_ITEMSOLI_CDFILSOLI AND
                           CDPRODUTO    = @V_GRAVA_CDPRODUTO;

                        IF @V_CDFILIOPELOG IS NULL BEGIN
                           SET @V_CDFILIOPELOG = 'OL_NULL';
                        END;

                        INSERT INTO ITMAPURPREC
                           (CDCENTITMAP,  NRSEQITMAP,   CDFILIAP,
                            DTENTRAPUT,   CDPRODITMAP,  NRCOLEITMAP,
                            CDFORNITMAP,  CDREGITMAP,   CDMARCITMAP,
                            QTSOLACOMP,   QTACOMP,      CDTIPCOBAP,
                            CDEMPRESAAP,  CDFORMPGTOAP, IDULTDIAPGTAF,
                            CONCKEYAP,    IDTPFORPGTAP, IDTIPOEMITAP,
                            IDTIPOFRETAP, NRPARCPGTOAP, CDSEGMARCCOL,
                            VRPRECUNIAP,  VRPERDESIAP,  NRDIAPGFIAP,
                            DSPZOPGTCOAP, VRPRECECOAP,  VRPRECONPIAP,
                            IDITMLISPRAP, NRLISTAITMAP, NRCOMPRA)
                        VALUES(@P_CDCENTCMP,
                               @P_NRSEQAPUR,
                               @V_ITEMSOLI_CDFILSOLI,
                               @V_ITEMSOLI_DTPROGENTR,
                               @V_GRAVA_CDPRODUTO,
                               @V_GRAVA_NRCOLEPRECO,
                               @V_GRAVA_CDFORNECED,
                               @V_GRAVA_CDREGIAO,
                               @V_GRAVA_CDMARCA,
                               @V_QTACOMPRAR_AUX,
                               @V_QTACOMPRAR_AUX,
                               @V_GRAVA_CDTIPCOB,
                               @V_CDEMPRESA,
                               @V_GRAVA_CDFORMPGTO,
                               @V_GRAVA_IDUTDIAPGCOL,
                               @V_CONCKEY+@V_CDFILIOPELOG+@V_IDPRODWEB+@V_IDAFOPERLOG,
                               @V_GRAVA_IDTPFOPGTCOL,
                               @V_IDTIPEMIT,
                               @V_GRAVA_IDTIPFREITM,
                               @V_GRAVA_NRPARCPGTCOL,
                               @V_GRAVA_CDSEGMARCCOL,
                               @V_GRAVA_VRPRECUNIITM,
                               @V_GRAVA_VRPERDESITM,
                               @V_GRAVA_NRDIAPGFXCOL,
                               @V_DSPZOPGTCONC,
                               @V_GRAVA_VRPRECECOITM,
                               @V_GRAVA_VRPRECOITMPI,
                               @V_GRAVA_IDITMLISPREC,
                               @V_GRAVA_NRSEQPRELIST,
                               @P_NRCOMPRA);

                        IF (@@ROWCOUNT > 0) BEGIN
                           SET @P_ROWSAFFECT = 'S';
                           IF ISNULL(@V_CDFILIAL, 'XXXX') <> @V_ITEMSOLI_CDFILSOLI BEGIN
                              SELECT @V_CDFILIAL_PARAM = MAX(PARCMPSUP.CDFILIAL)
                                FROM PARCMPSUP, PARASUPRI, FILIAL
                               WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                                 AND PARASUPRI.CDFILIAL = ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                                 AND ISNULL(PARCMPSUP.IDUTAPROVSOL, 'N')    = 'S'
                                 AND ISNULL(PARASUPRI.IDULTDESTSOL, 'N')    = 'S'
                                 AND ISNULL(PARASUPRI.IDEXIGAPRGERCMP, 'N') = 'S'
                                 AND PARCMPSUP.CDSUBGRPROD IS NOT NULL
                                 AND FILIAL.CDFILIAL = @V_ITEMSOLI_CDFILSOLI;
                              IF @V_CDFILIAL_PARAM IS NOT NULL BEGIN
                                 DELETE
                                   FROM APROVCOMPRA
                                  WHERE NRCOMPRA = @P_NRCOMPRA;
                                 UPDATE COMPRA
                                    SET IDSITUCOMPRA = '8'
                                  WHERE NRCOMPRA = @P_NRCOMPRA;
                              END;
                              SET @V_CDFILIAL = @V_ITEMSOLI_CDFILSOLI;
                           END;
                        END;
                     FETCH NEXT FROM C_GRAVA INTO @V_GRAVA_CDFILIAL,
                                                  @V_GRAVA_CDPRODUTO,
                                                  @V_GRAVA_VRFATOCONV,
                                                  @V_GRAVA_NRCOLEPRECO,
                                                  @V_GRAVA_CDFORNECED,
                                                  @V_GRAVA_CDREGIAO,
                                                  @V_GRAVA_CDMARCA,
                                                  @V_GRAVA_CDTIPCOB,
                                                  @V_GRAVA_CDFORMPGTO,
                                                  @V_GRAVA_IDUTDIAPGCOL,
                                                  @V_GRAVA_IDTPFOPGTCOL,
                                                  @V_GRAVA_IDTIPFREITM,
                                                  @V_GRAVA_NRPARCPGTCOL,
                                                  @V_GRAVA_CDSEGMARCCOL,
                                                  @V_GRAVA_VRPRECUNIITM,
                                                  @V_GRAVA_VRPERDESITM,
                                                  @V_GRAVA_NRDIAPGFXCOL,
                                                  @V_GRAVA_VRPRECECOITM,
                                                  @V_GRAVA_VRPRECOITMPI,
                                                  @V_GRAVA_IDITMLISPREC,
                                                  @V_GRAVA_NRSEQPRELIST,
                                                  @V_DSPZOPGTCONC;

                     END;
                     CLOSE C_GRAVA;
                     DEALLOCATE C_GRAVA;
                  END;
                  SET @V_QTACOMPRAR = 0;
               END;
            END;
         FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_CDPRODESTO,
                                         @V_ITEMSOLI_CDFILSOLI,
                                         @V_ITEMSOLI_DTPROGENTR,
                                         @V_ITEMSOLI_CDREGIAO,
                                         @V_ITEMSOLI_QTDEACOMP;


         END;
         CLOSE C_ITEMSOLI;
         DEALLOCATE C_ITEMSOLI;
      END ELSE BEGIN
         DECLARE C_ITEMSOLI CURSOR FOR
            (
            SELECT /*+ ORDERED */
               ITEMSOLI.CDPRODUTO,
               ITEMSOLI.CDFILSOLI,
               ITEMSOLI.DTPROGENTR,
               FILIAL.CDREGIAO,
               SUM(ITEMSOLI.QTSOLIPROD) AS QTDEACOMP /* QUANTIDADE CONVERTIDA PARA ESTOQUE */
            FROM
               FILIAL,
               PRODCOMPRA,
               ITEMSOLI,
               PRODUTO
            WHERE
               (FILIAL.CDFILIAL      = @V_FILGRUPFILI_CDFILIAL)     AND
               (PRODCOMPRA.NRCOMPRA  = @P_NRCOMPRA)                 AND
               (PRODCOMPRA.CDFILSOLI = FILIAL.CDFILIAL)            AND
               (ITEMSOLI.CDFILSOLI   = PRODCOMPRA.CDFILSOLI)       AND
               (ITEMSOLI.CDFILLAN    = PRODCOMPRA.CDFILLAN)        AND
               (ITEMSOLI.NRSOLICMP   = PRODCOMPRA.NRSOLICMP)       AND
               (ITEMSOLI.CDPRODUTO   = PRODCOMPRA.CDPRODUTO)       AND
               (ITEMSOLI.DTPROGENTR  = PRODCOMPRA.DTPROGENTR)      AND
               (ITEMSOLI.IDITMCONS   = 'N')                        AND
               (ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) =  @P_CDCENTCMP) AND
               (FILIAL.IDCNTRRESC   <> 'S') AND
               (ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO) AND
               (CASE ITEMSOLI.IDSOLIAPROV
                   WHEN NULL THEN 'S'
                   ELSE ITEMSOLI.IDSOLIAPROV
                END) = 'S' AND

               EXISTS(SELECT
                         1
                      FROM
                         PRODCOMP,
                         PRODUTO PC
                      WHERE
                         PRODCOMP.CDPRODUTO  = PC.CDPRODUTO  AND
                         PRODCOMP.CDOPERADOR = @P_CDCOMPRADOR AND
                         PRODUTO.CDARVPROD LIKE PC.CDARVPROD + '%')
            GROUP BY
               FILIAL.CDREGIAO,
               ITEMSOLI.CDFILSOLI,
               ITEMSOLI.CDPRODUTO,
               ITEMSOLI.DTPROGENTR)

         OPEN C_ITEMSOLI;
         FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_CDPRODUTO,
                                         @V_ITEMSOLI_CDFILSOLI,
                                         @V_ITEMSOLI_DTPROGENTR,
                                         @V_ITEMSOLI_CDREGIAO,
                                         @V_ITEMSOLI_QTDEACOMP;



         WHILE (@@FETCH_STATUS = 0) BEGIN


            SELECT
               @V_IDPRODATIV = ISNULL(MAX(PRODFILI.IDPRODATIV), 'A')
            FROM
               PRODFILI
            WHERE
               PRODFILI.CDFILIAL  = @V_ITEMSOLI_CDFILSOLI AND
              PRODFILI.CDPRODUTO = @V_ITEMSOLI_CDPRODUTO;

            IF @V_IDPRODATIV = 'A' BEGIN
               SET @V_CTPRODCMP = 0;
               SELECT
                  @V_CTPRODCMP = COUNT(*)
               FROM
                  PRODCMPFILI,
                  PRODUTO,
                  PRODUTO P
               WHERE
                  P.CDPRODUTO = @V_ITEMSOLI_CDPRODUTO AND
                  PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO AND
                  PRODCMPFILI.CDFILIAL = @V_ITEMSOLI_CDFILSOLI AND
                  PRODCMPFILI.CDFILIAL <> @P_FILIPROC AND

                  P.CDARVPROD LIKE PRODUTO.CDARVPROD+'%' AND
                  PRODUTO.CDARVPROD > (SELECT
                                         (CASE MAX(PR.CDARVPROD)
                                             WHEN NULL THEN '0'
                                             ELSE MAX(PR.CDARVPROD)
                                          END)
                                       FROM
                                          PRODNCMP,
                                          PRODUTO PR
                                       WHERE
                                          PRODNCMP.CDPRODUTO = PR.CDPRODUTO AND
                                          P.CDARVPROD LIKE PR.CDARVPROD+'%' AND
                                          PRODNCMP.CDFILIAL = @V_ITEMSOLI_CDFILSOLI);
               IF @V_CTPRODCMP = 0 BEGIN
                  SET @V_CTPRODCMP = 1;
               END ELSE BEGIN
                  SET @V_CTPRODCMP = 0;
               END;

               IF @V_CTPRODCMP > 0 BEGIN
                  SET @V_QTACOMPRAR = @V_ITEMSOLI_QTDEACOMP;
                  -- DBMS_OUTPUT.PUT_LINE('AF');
                  IF @V_QTDECOMP IS NULL BEGIN
                     SET @V_QTDECOMP = 0;
                  END;

                  SELECT /*+ index (itemautf itemautf_03) */
                     V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF * PRODUTO.VRFATOCONV) /* QTDE CONVERTIDA PARA ESTOQUE */
                  FROM
                    AUTOFORNE,
                    ITEMAUTF,
                    PRODUTO,
                    ITMAPURPREC
                  WHERE
                    (PRODUTO.CDPRODESTO     = @V_ITEMSOLI_CDPRODUTO)                     AND
                    (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)                        AND
                    (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)                        AND
                    (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN)                       AND
                    (AUTOFORNE.IDAUTOFORNEX = 'N')                                       AND
                    (ISNULL(AUTOFORNE.IDBAIXAAF, '0') <> '5')                            AND
                    (ITEMAUTF.CDFILDEST     = @V_ITEMSOLI_CDFILSOLI)                     AND
                    (ITEMAUTF.CDPRODUTO     = PRODUTO.CDPRODUTO)                         AND
                    (ITEMAUTF.DTENTRITMSOL  = @V_ITEMSOLI_DTPROGENTR)                    AND
                    (ITEMAUTF.CDFILDEST     = ITMAPURPREC.CDFILIAP)                      AND
                    (ITEMAUTF.CDMARCA       = ITMAPURPREC.CDMARCITMAP)                   AND
                    (ITEMAUTF.CDPRODUTO     = ITMAPURPREC.CDPRODITMAP)                   AND
                    (ITEMAUTF.DTPROGENTAF   = ITMAPURPREC.DTENTRAPUT)                    AND
                    (AUTOFORNE.CDFORNECED   = ITMAPURPREC.CDFORNITMAP)                   AND
                    (AUTOFORNE.NRSEQAPURAF  = ITMAPURPREC.NRSEQITMAP)                    AND
                    (ISNULL(ITMAPURPREC.NRCOMPRA, @P_NRCOMPRA)  =  @P_NRCOMPRA)          AND
                    (ITMAPURPREC.NRCOMPRA IS NOT NULL)
                  GROUP BY
                    ITEMAUTF.CDFILDEST,
                    ITEMAUTF.DTENTRITMSOL,
                    PRODUTO.CDPRODESTO;

                  SET @V_QTACOMPRAR = @V_QTACOMPRAR - @V_QTDECOMP;
                  IF ROUND(@V_QTACOMPRAR,3) > 0 BEGIN
                     DECLARE C_GRAVA CURSOR FOR
                        (
                        SELECT
                           ITEMCOLE.CDFILIAL,
                           ITEMCOLE.CDPRODUTO,
                           PRODUTO.VRFATOCONV,
                           ITEMCOLE.NRCOLEPRECO,
                           ITEMCOLE.CDFORNECED,
                           ITEMCOLE.CDREGIAO,
                           ITEMCOLE.CDMARCA,
                           ITEMCOLE.CDTIPCOB,
                           ITEMCOLE.CDFORMPGTO,
                           ITEMCOLE.IDUTDIAPGCOL,
                           ITEMCOLE.IDTPFOPGTCOL,
                           ITEMCOLE.IDTIPFREITM,
                           ITEMCOLE.NRPARCPGTCOL,
                           ITEMCOLE.CDSEGMARCCOL,
                           ITEMCOLE.VRPRECUNIITM,
                           ITEMCOLE.VRPERDESITM,
                           ITEMCOLE.NRDIAPGFXCOL,
                           ITEMCOLE.VRPRECECOITM,
                           ITEMCOLE.VRPRECOITMPI,
                           ITEMCOLE.IDITMLISPREC,
                           ITEMCOLE.NRSEQPRELIST,
                           ITEMCOLE.DSPZOPGTCONC --T R I G G E R
                        FROM
                           ITEMCOLE,
                           PRODUTO,
                           FORNECEDOR,
                           COLETAPR
                        WHERE
                           COLETAPR.CDFILIAL      = @P_CDCENTCMP              AND
                           COLETAPR.CDOPERADOR    = @P_CDCOMPRADOR            AND
                           COLETAPR.NRCOMPRA      = @P_NRCOMPRA               AND
                           COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL        AND
                           COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO     AND
                           @V_ITEMSOLI_CDPRODUTO = ITEMCOLE.CDPRODUTO       AND
                           ITEMCOLE.CDPRODUTO     = PRODUTO.CDPRODUTO        AND
                           ITEMCOLE.VRPRECUNIITM <> 0                        AND
                           ITEMCOLE.CDREGIAO      = @V_ITEMSOLI_CDREGIAO      AND
                           (@V_ITEMSOLI_DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM) AND
                           FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED      AND
                           FORNECEDOR.IDSITUCADA  = 'A'                      AND
                           FORNECEDOR.IDTIPOFORN <> 'A'                      AND
                           ((@V_IDUTISTATCOT = 'N') OR (ISNULL(COLETAPR.IDSITUCOLETA, 'C') = 'C')) AND

                        NOT EXISTS
                           (SELECT
                               1
                            FROM
                               REFOREG
                            WHERE
                               REFOREG.CDREGIAO   = @V_ITEMSOLI_CDREGIAO AND
                               REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED) AND

                        NOT EXISTS
                           (SELECT
                               1
                            FROM
                               QFOPRODFORN,
                               PARASUPRI
                            WHERE
                               PARASUPRI.CDFILIAL = @P_CDCENTCMP  AND
                               (QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                               (QFOPRODFORN.CDFORNECED= ITEMCOLE.CDFORNECED) AND
                               ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                               ((QFOPRODFORN.IDFORNAPROV = 'S') AND
                               ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                 COLETAPR.DTCOLEPREC > DATEADD(MM, 1, QFOPRODFORN.DTVALPRFORN) - DAY(DATEADD(MM, 1, QFOPRODFORN.DTVALPRFORN))) OR
                                (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                 COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)) ) )) AND

                        NOT EXISTS
                           (SELECT
                               1
                            FROM
                               QFOMARPROD, PARASUPRI
                            WHERE
                               (PARASUPRI.CDFILIAL = @P_CDCENTCMP)            AND
                               (QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                               (QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA)     AND
                               ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                               ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                               ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                 COLETAPR.DTCOLEPREC > DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA) - DAY(DATEADD(MM, 1, QFOMARPROD.DTVALAPROVA))) OR
                                (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                 COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)) ) )) AND

                        EXISTS
                           (SELECT
                               1
                            FROM
                               QFOMARPROD
                            WHERE
                               QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO AND
                               QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA

                            UNION

                            SELECT
                               1
                            FROM
                               PARASUPRI
                            WHERE
                               PARASUPRI.CDFILIAL    = @P_CDCENTCMP AND
                               (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL)) AND

                        NOT EXISTS
                           (SELECT 1
                               FROM QUALIFICACAO, PARASUPRI
                            WHERE (FORNECEDOR.CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
                                  (PARASUPRI.CDFILIAL        = @P_CDCENTCMP)           AND
                                  (FORNECEDOR.IDFORNAUTO     = 'N')                   AND
                                  ((QUALIFICACAO.IDPERCOTCMP = '2')                   OR
                                  ((PARASUPRI.IDULTIDTVALQ  = 'D'                    AND
                                    COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF)       OR
                                  (PARASUPRI.IDULTIDTVALQ = 'M'                      AND
                                   COLETAPR.DTCOLEPREC > DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF) - DAY(DATEADD(MM, 1, FORNECEDOR.DTVALQUALIF))))) ) AND

                        NOT EXISTS /* Tirando fornecedores que no atendam s filiais */
                          (SELECT
                               1
                            FROM
                               REFORFIL
                            WHERE
                               REFORFIL.CDFILIAL   = @V_ITEMSOLI_CDFILSOLI AND
                               REFORFIL.CDPERIENTR IS NULL AND
                               REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED ))
                     OPEN C_GRAVA;
                     FETCH NEXT FROM C_GRAVA INTO @V_GRAVA_CDFILIAL,
                                                  @V_GRAVA_CDPRODUTO,
                                                  @V_GRAVA_VRFATOCONV,
                                                  @V_GRAVA_NRCOLEPRECO,
                                                  @V_GRAVA_CDFORNECED,
                                                  @V_GRAVA_CDREGIAO,
                                                  @V_GRAVA_CDMARCA,
                                                  @V_GRAVA_CDTIPCOB,
                                                  @V_GRAVA_CDFORMPGTO,
                                                  @V_GRAVA_IDUTDIAPGCOL,
                                                  @V_GRAVA_IDTPFOPGTCOL,
                                                  @V_GRAVA_IDTIPFREITM,
                                                  @V_GRAVA_NRPARCPGTCOL,
                                                  @V_GRAVA_CDSEGMARCCOL,
                                                  @V_GRAVA_VRPRECUNIITM,
                                                  @V_GRAVA_VRPERDESITM,
                                                  @V_GRAVA_NRDIAPGFXCOL,
                                                  @V_GRAVA_VRPRECECOITM,
                                                  @V_GRAVA_VRPRECOITMPI,
                                                  @V_GRAVA_IDITMLISPREC,
                                                  @V_GRAVA_NRSEQPRELIST,
                                                  @V_DSPZOPGTCONC;

                     WHILE (@@FETCH_STATUS = 0) BEGIN

                        SET @V_CTIMPOSTO = NULL;
                        SET @V_CONCKEY   = NULL;

                        IF @V_IDSEPAFIMP = 'S' BEGIN
                           SELECT
                              @V_CTIMPOSTO = COUNT(*)
                           FROM
                              IMPCOLET
                           WHERE
                              CDFILIAL    = @V_GRAVA_CDFILIAL    AND
                              NRCOLEPRECO = @V_GRAVA_NRCOLEPRECO AND
                              CDMARCA     = @V_GRAVA_CDMARCA     AND
                              CDREGIAO    = @V_GRAVA_CDREGIAO    AND
                              CDFORNECED  = @V_GRAVA_CDFORNECED  AND
                              CDPRODUTO   = @V_GRAVA_CDPRODUTO;

                           IF @V_CTIMPOSTO = 0 BEGIN
                              SET @V_CONCKEY = '';
                           END ELSE BEGIN
                              IF @V_CTIMPOSTO = 1 BEGIN
                                 SELECT DISTINCT
                                    @V_CONCKEY = CDIMPOSTO
                                 FROM
                                    IMPCOLET
                                 WHERE
                                    CDFILIAL    = @V_GRAVA_CDFILIAL    AND
                                    NRCOLEPRECO = @V_GRAVA_NRCOLEPRECO AND
                                    CDMARCA     = @V_GRAVA_CDMARCA     AND
                                    CDREGIAO    = @V_GRAVA_CDREGIAO    AND
                                    CDFORNECED  = @V_GRAVA_CDFORNECED  AND
                                    CDPRODUTO   = @V_GRAVA_CDPRODUTO;
                              END ELSE BEGIN
                                 IF @V_CTIMPOSTO > 1 BEGIN
                                    SET @V_CONCKEY = '*';
                                 END;
                              END;
                           END;
                        END;

                        SET @V_EMITENTE  = TEKNISA.EMITENTE(@V_ITEMSOLI_CDFILSOLI, @V_GRAVA_CDPRODUTO, @V_GRAVA_CDFORNECED);

                        SET @V_CDEMPRESA = SUBSTRING(@V_EMITENTE, 3, 2);

                        SET @V_CONCKEY   = ISNULL(@V_CONCKEY, '') + @V_GRAVA_CDFILIAL + @V_GRAVA_CDFORNECED + ISNULL(SUBSTRING(@V_EMITENTE, 3, 2), '')+
                                           ISNULL(@V_GRAVA_IDTPFOPGTCOL, '') +
                                           ISNULL(@V_GRAVA_CDTIPCOB, '')     + ISNULL(@V_GRAVA_IDTIPFREITM, '')  +
                                           ISNULL(@V_GRAVA_CDFORMPGTO, '')   + ISNULL(CONVERT(VARCHAR, @V_GRAVA_NRPARCPGTCOL), '') +
                                           ISNULL(CONVERT(VARCHAR, @V_GRAVA_NRDIAPGFXCOL), '') + ISNULL(@V_GRAVA_IDUTDIAPGCOL, '') +
                                           ISNULL(SUBSTRING(@V_EMITENTE, 1, 1), '');


                        SET @V_IDTIPEMIT = ISNULL(SUBSTRING(@V_EMITENTE, 1, 1), '');

                        SELECT
                           @V_VRARREDCMP = ISNULL(MAX(VRARREDCMP), 0)
                        FROM
                           PRODUTO
                        WHERE
                           CDPRODUTO = @V_GRAVA_CDPRODUTO;


                        SET @V_QTACOMPRAR_AUX = @V_QTACOMPRAR; /* CONVERTE PARA UNIDADE DE COMPRA */
                        IF (((CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP)  - (ROUND(@V_QTACOMPRAR_AUX / @V_VRARREDCMP, 0, 1))) <> 0) AND @V_VRARREDCMP > 0 BEGIN
                           SET @V_QTACOMPRAR_AUX = CEILING(CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP) * @V_VRARREDCMP;
                        END;

                        SET @V_IDAFOPERLOG = 'X';
                        SELECT
                           @V_IDAFOPERLOG = ISNULL(MAX('2'),'X')
                        FROM
                           PARAMPRODSUP
                        WHERE
                           CDFILIAL     = @V_ITEMSOLI_CDFILSOLI AND
                           CDPRODUTO    = @V_GRAVA_CDPRODUTO         AND
                           CDFILIOPELOG IS NOT NULL;

                         SET @V_IDPRODWEB = 'N';
                         SELECT
                            @V_IDPRODWEB = ISNULL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
                         FROM
                            PARAMPRODSUP
                         WHERE
                            CDFILIAL   = @V_ITEMSOLI_CDFILSOLI AND
                            CDPRODUTO  = @V_GRAVA_CDPRODUTO         AND
                            CDFORNECED = @V_GRAVA_CDFORNECED;

                         SELECT
                            @V_CDFILIOPELOG = MAX(CDFILIOPELOG)
                         FROM
                            PARAMPRODSUP
                         WHERE
                            CDFILIAL     = @V_ITEMSOLI_CDFILSOLI AND
                            CDPRODUTO    = @V_GRAVA_CDPRODUTO;

                         IF @V_CDFILIOPELOG IS NULL BEGIN
                            SET @V_CDFILIOPELOG = 'OL_NULL';
                         END;

                         INSERT INTO ITMAPURPREC
                            (CDCENTITMAP,  NRSEQITMAP,   CDFILIAP,
                             DTENTRAPUT,   CDPRODITMAP,  NRCOLEITMAP,
                             CDFORNITMAP,  CDREGITMAP,   CDMARCITMAP,
                             QTSOLACOMP,   QTACOMP,      CDTIPCOBAP,
                             CDEMPRESAAP,  CDFORMPGTOAP, IDULTDIAPGTAF,
                             CONCKEYAP,    IDTPFORPGTAP, IDTIPOEMITAP,
                             IDTIPOFRETAP, NRPARCPGTOAP, CDSEGMARCCOL,
                             VRPRECUNIAP,  VRPERDESIAP,  NRDIAPGFIAP,
                             DSPZOPGTCOAP, VRPRECECOAP,  VRPRECONPIAP,
                             IDITMLISPRAP, NRLISTAITMAP, NRCOMPRA)
                         VALUES(@P_CDCENTCMP,
                                @P_NRSEQAPUR,
                                @V_ITEMSOLI_CDFILSOLI,
                                @V_ITEMSOLI_DTPROGENTR,
                                @V_GRAVA_CDPRODUTO,
                                @V_GRAVA_NRCOLEPRECO,
                                @V_GRAVA_CDFORNECED,
                                @V_GRAVA_CDREGIAO,
                                @V_GRAVA_CDMARCA,
                                @V_QTACOMPRAR_AUX,
                                @V_QTACOMPRAR_AUX,
                                @V_GRAVA_CDTIPCOB,
                                @V_CDEMPRESA,
                                @V_GRAVA_CDFORMPGTO,
                                @V_GRAVA_IDUTDIAPGCOL,
                                @V_CONCKEY+@V_CDFILIOPELOG+@V_IDPRODWEB+@V_IDAFOPERLOG,
                                @V_GRAVA_IDTPFOPGTCOL,
                                @V_IDTIPEMIT,
                                @V_GRAVA_IDTIPFREITM,
                                @V_GRAVA_NRPARCPGTCOL,
                                @V_GRAVA_CDSEGMARCCOL,
                                @V_GRAVA_VRPRECUNIITM,
                                @V_GRAVA_VRPERDESITM,
                                @V_GRAVA_NRDIAPGFXCOL,
                                @V_DSPZOPGTCONC,
                                @V_GRAVA_VRPRECECOITM,
                                @V_GRAVA_VRPRECOITMPI,
                                @V_GRAVA_IDITMLISPREC,
                                @V_GRAVA_NRSEQPRELIST,
                                @P_NRCOMPRA);

                         IF (@@ROWCOUNT > 0) BEGIN
                            SET @P_ROWSAFFECT = 'S';
                            IF ISNULL(@V_CDFILIAL, 'XXXX') <> @V_ITEMSOLI_CDFILSOLI BEGIN
                               SELECT @V_CDFILIAL_PARAM = MAX(PARCMPSUP.CDFILIAL)
                                 FROM PARCMPSUP, PARASUPRI, FILIAL
                                WHERE PARCMPSUP.CDFILIAL = FILIAL.CDFILIAL
                                  AND PARASUPRI.CDFILIAL = ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)
                                  AND ISNULL(PARCMPSUP.IDUTAPROVSOL, 'N')    = 'S'
                                  AND ISNULL(PARASUPRI.IDULTDESTSOL, 'N')    = 'S'
                                  AND ISNULL(PARASUPRI.IDEXIGAPRGERCMP, 'N') = 'S'
                                  AND PARCMPSUP.CDSUBGRPROD IS NOT NULL
                                  AND FILIAL.CDFILIAL = @V_ITEMSOLI_CDFILSOLI;
                               IF @V_CDFILIAL_PARAM IS NOT NULL BEGIN
                                  DELETE
                                    FROM APROVCOMPRA
                                   WHERE NRCOMPRA = @P_NRCOMPRA;
                                  UPDATE COMPRA
                                     SET IDSITUCOMPRA = '8'
                                   WHERE NRCOMPRA = @P_NRCOMPRA;
                               END;
                               SET @V_CDFILIAL = @V_ITEMSOLI_CDFILSOLI;
                            END;
                         END;
                     FETCH NEXT FROM C_GRAVA INTO @V_GRAVA_CDFILIAL,
                                                  @V_GRAVA_CDPRODUTO,
                                                  @V_GRAVA_VRFATOCONV,
                                                  @V_GRAVA_NRCOLEPRECO,
                                                  @V_GRAVA_CDFORNECED,
                                                  @V_GRAVA_CDREGIAO,
                                                  @V_GRAVA_CDMARCA,
                                                  @V_GRAVA_CDTIPCOB,
                                                  @V_GRAVA_CDFORMPGTO,
                                                  @V_GRAVA_IDUTDIAPGCOL,
                                                  @V_GRAVA_IDTPFOPGTCOL,
                                                  @V_GRAVA_IDTIPFREITM,
                                                  @V_GRAVA_NRPARCPGTCOL,
                                                  @V_GRAVA_CDSEGMARCCOL,
                                                  @V_GRAVA_VRPRECUNIITM,
                                                  @V_GRAVA_VRPERDESITM,
                                                  @V_GRAVA_NRDIAPGFXCOL,
                                                  @V_GRAVA_VRPRECECOITM,
                                                  @V_GRAVA_VRPRECOITMPI,
                                                  @V_GRAVA_IDITMLISPREC,
                                                  @V_GRAVA_NRSEQPRELIST,
                                                  @V_DSPZOPGTCONC;

                     END;
                     CLOSE C_GRAVA;
                     DEALLOCATE C_GRAVA;
                  END;
                  SET @V_QTACOMPRAR = 0;
               END;
            END;
         FETCH NEXT FROM C_ITEMSOLI INTO @V_ITEMSOLI_CDPRODUTO,
                                         @V_ITEMSOLI_CDFILSOLI,
                                         @V_ITEMSOLI_DTPROGENTR,
                                         @V_ITEMSOLI_CDREGIAO,
                                         @V_ITEMSOLI_QTDEACOMP;
         END;
         CLOSE C_ITEMSOLI;
         DEALLOCATE C_ITEMSOLI;
      END;
   FETCH NEXT FROM C_FILGRUPFILI INTO @V_FILGRUPFILI_CDFILIAL;
   END;
   CLOSE C_FILGRUPFILI;
   DEALLOCATE C_FILGRUPFILI;

   IF @P_ROWSAFFECT <> 'S' BEGIN
      DELETE
         FROM APURPRECO
         WHERE
            (CDFILCENTCMP = @P_CDCENTCMP) AND
            (NRAPURPREC   = @P_NRSEQAPUR);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURA_COMPRA','5.40.000';
GO
